DECLARE SUB LoadPalette ()
DECLARE SUB InitImageData (FileName$, ImageArray%())
DECLARE SUB MakeImageIndex (ImageArray%(), IndexArray%())
'$INCLUDE: 'DirectQB.bi'
CLS
SCREEN 13
A = DQBinit(1, 0)
IF A <> 0 THEN DQBclose: END
'---------------------------------------------------------------------------'
DIM SHARED MainPAth$, CurrentTile, TileSet$, Tiles%(1 TO 1), Index%(1 TO 1)
DIM SHARED PixPath$, Pal AS STRING * 768
DQBresetMouse
DQBmouseShow
'---------------------------------------------------------------------------'
MainPAth$ = "C:\ben\qb2\rpg\": PixPath$ = "pp\images\"
CurrentTile = 1
'---------------------------------------------------------------------------'
TYPE BlockType
Mask AS INTEGER
WalkAble AS INTEGER
END TYPE
DIM SHARED Block(120) AS BlockType

LoadPalette
LINE INPUT "> "; TileSet$
InitImageData MainPAth$ + PixPath$ + TileSet$, Tiles%()
MakeImageIndex Tiles%(), Index%()

DQBinstallKeyboard
DQBclearLayer 0
Main:
DQBwait 7
IF CurrentTile > 120 THEN CurrentTile = 1
IF CurrentTile < 1 THEN CurrentTile = 120
DQBboxf 0, 0, 0, 16, 16, 16
DQBput 0, 0, 0, VARSEG(Tiles%(Index%(CurrentTile))), VARPTR(Tiles%(Index%(CurrentTile)))
LOCATE 4, 1: PRINT "     "
LOCATE 4, 1: PRINT CurrentTile
COLOR 4
LOCATE 6, 1: PRINT "                "
LOCATE 7, 1: PRINT "                "
IF Block(CurrentTile).Mask = TRUE THEN LOCATE 6, 1: PRINT "MASKED"
IF Block(CurrentTile).WalkAble = TRUE THEN LOCATE 7, 1: PRINT "WALKABLE"
COLOR 15
DO
IF DQBkey(KEYESC) THEN EXIT DO
IF DQBkey(KEYLEFT) THEN CurrentTile = CurrentTile - 1: GOTO Main
IF DQBkey(KEYRIGHT) THEN CurrentTile = CurrentTile + 1: GOTO Main
IF DQBmouseLB = -1 THEN
IF Block(CurrentTile).Mask = FALSE THEN Block(CurrentTile).Mask = TRUE ELSE Block(CurrentTile).Mask = FALSE
GOTO Main
END IF
IF DQBmouseRB = -1 THEN
IF Block(CurrentTile).WalkAble = FALSE THEN Block(CurrentTile).WalkAble = TRUE ELSE Block(CurrentTile).WalkAble = FALSE
GOTO Main
END IF


LOOP
CLS
DQBremoveKeyBoard
LINE INPUT "> "; File$
OPEN MainPAth$ + File$ FOR OUTPUT AS #1
FOR Z = 1 TO 120
PRINT #1, Block(Z).Mask, Block(Z).WalkAble
NEXT Z
CLOSE #1
PRINT "Saved!!! Done!"



DQBclose

REM $DYNAMIC
DEFSNG A-Z
SUB InitImageData (FileName$, ImageArray%())

    IF FileName$ <> "" THEN
        '***** Read image data from file *****

        'Establish size of integer array required.
        FileNo = FREEFILE
        OPEN FileName$ FOR BINARY AS #FileNo
        Ints = (LOF(FileNo) - 7) \ 2
        CLOSE #FileNo
        REDIM ImageArray%(1 TO Ints)

        'Load image data directly into array memory.
        DEF SEG = VARSEG(ImageArray%(1))
        BLOAD FileName$, 0
        DEF SEG
    ELSE
        '***** Read image data from DATA statements *****

        'Establish size of integer array required.
        READ IntCount
        REDIM ImageArray%(1 TO IntCount)

        'READ image DATA into array.
        FOR n = 1 TO IntCount
            READ x
            ImageArray%(n) = x
        NEXT n
    END IF

END SUB

DEFINT A-Z
SUB LoadPalette

FF = FREEFILE
OPEN MainPAth$ + "zero.pal" FOR BINARY AS #FF
GET #FF, , Pal
CLOSE #FF
DQBsetPal Pal

END SUB

DEFSNG A-Z
SUB MakeImageIndex (ImageArray%(), IndexArray%())

    'The index will initially be built in a temporary array, allowing
    'for the maximum 1000 images per file.
    DIM Temp%(1 TO 120)
    Ptr& = 1: IndexNo = 1: LastInt = UBOUND(ImageArray%)
    DO
        Temp%(IndexNo) = Ptr&
        IndexNo = IndexNo + 1

        'Evaluate descriptor of currently referenced image to
        'calculate the beginning of the next image.
        x& = (ImageArray%(Ptr&) \ 8) * (ImageArray%(Ptr& + 1)) + 4
        IF x& MOD 2 THEN x& = x& + 1
        Ptr& = Ptr& + (x& \ 2)
    LOOP WHILE Ptr& < LastInt

    LastImage = IndexNo - 1

    'Copy the image index values into the actual index array.
    REDIM IndexArray%(1 TO LastImage)
    FOR n = 1 TO LastImage
        IndexArray%(n) = Temp%(n)
    NEXT n


END SUB

